1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# Runs a set of tests in a given subdirectory.
5export skip_rc=4
6export timeout_rc=124
7export logfile=/dev/stdout
8export per_test_logging=
9
10# Defaults for "settings" file fields:
11# "timeout" how many seconds to let each test run before failing.
12export kselftest_default_timeout=45
13
14# There isn't a shell-agnostic way to find the path of a sourced file,
15# so we must rely on BASE_DIR being set to find other tools.
16if [ -z "$BASE_DIR" ]; then
17	echo "Error: BASE_DIR must be set before sourcing." >&2
18	exit 1
19fi
20
21# If Perl is unavailable, we must fall back to line-at-a-time prefixing
22# with sed instead of unbuffered output.
23tap_prefix()
24{
25	if [ ! -x /usr/bin/perl ]; then
26		sed -e 's/^/# /'
27	else
28		"$BASE_DIR"/kselftest/prefix.pl
29	fi
30}
31
32tap_timeout()
33{
34	# Make sure tests will time out if utility is available.
35	if [ -x /usr/bin/timeout ] ; then
36		/usr/bin/timeout --foreground "$kselftest_timeout" $1
37	else
38		$1
39	fi
40}
41
42run_one()
43{
44	DIR="$1"
45	TEST="$2"
46	NUM="$3"
47
48	BASENAME_TEST=$(basename $TEST)
49
50	# Reset any "settings"-file variables.
51	export kselftest_timeout="$kselftest_default_timeout"
52	# Load per-test-directory kselftest "settings" file.
53	settings="$BASE_DIR/$DIR/settings"
54	if [ -r "$settings" ] ; then
55		while read line ; do
56			# Skip comments.
57			if echo "$line" | grep -q '^#'; then
58				continue
59			fi
60			field=$(echo "$line" | cut -d= -f1)
61			value=$(echo "$line" | cut -d= -f2-)
62			eval "kselftest_$field"="$value"
63		done < "$settings"
64	fi
65
66	TEST_HDR_MSG="selftests: $DIR: $BASENAME_TEST"
67	echo "# $TEST_HDR_MSG"
68	if [ ! -e "$TEST" ]; then
69		echo "# Warning: file $TEST is missing!"
70		echo "not ok $test_num $TEST_HDR_MSG"
71	else
72		cmd="./$BASENAME_TEST"
73		if [ ! -x "$TEST" ]; then
74			echo "# Warning: file $TEST is not executable"
75
76			if [ $(head -n 1 "$TEST" | cut -c -2) = "#!" ]
77			then
78				interpreter=$(head -n 1 "$TEST" | cut -c 3-)
79				cmd="$interpreter ./$BASENAME_TEST"
80			else
81				echo "not ok $test_num $TEST_HDR_MSG"
82				return
83			fi
84		fi
85		cd `dirname $TEST` > /dev/null
86		((((( tap_timeout "$cmd" 2>&1; echo $? >&3) |
87			tap_prefix >&4) 3>&1) |
88			(read xs; exit $xs)) 4>>"$logfile" &&
89		echo "ok $test_num $TEST_HDR_MSG") ||
90		(rc=$?;	\
91		if [ $rc -eq $skip_rc ]; then	\
92			echo "ok $test_num $TEST_HDR_MSG # SKIP"
93		elif [ $rc -eq $timeout_rc ]; then \
94			echo "#"
95			echo "not ok $test_num $TEST_HDR_MSG # TIMEOUT $kselftest_timeout seconds"
96		else
97			echo "not ok $test_num $TEST_HDR_MSG # exit=$rc"
98		fi)
99		cd - >/dev/null
100	fi
101}
102
103run_many()
104{
105	echo "TAP version 13"
106	DIR="${PWD#${BASE_DIR}/}"
107	test_num=0
108	total=$(echo "$@" | wc -w)
109	echo "1..$total"
110	for TEST in "$@"; do
111		BASENAME_TEST=$(basename $TEST)
112		test_num=$(( test_num + 1 ))
113		if [ -n "$per_test_logging" ]; then
114			logfile="/tmp/$BASENAME_TEST"
115			cat /dev/null > "$logfile"
116		fi
117		run_one "$DIR" "$TEST" "$test_num"
118	done
119}
120